# CommentConverter 0.1.0 Docs

This document tries to describe what has been done and how everything works so far. I'll try to keep it short and hopefully I
won't repeat myself too much. It's probably not complete but most of the important things should be here and already mentioned
in the post I uploaded this with.

For short usage examples refer to [Usage](./Usage.md).

## Current report from user side

### What works

- We can convert comments to html
- Replies can be shown and hidden using ~~ugly~~ button if JS is enabled
- We have some kind of youtube-style look
- We have links to user channels (linking directly from name for now)
- Replies are sorted __and__ chained correctly unlike in prev version
- Debug info included (some replies are broken by youtube and the debug should help to detect if its mine fuckup or youtubes)
- There should be some backwards compatibility for parsing old comments without certain things (avatars, channel links)

### Whats broken/not implemented

- Currently the quoting is kinda broken because clicking the "link" marks entire reply chain instad of just root comment
- The "Show more" button is not implemented (we should do that eventually, people use it for dramatic effects quite a lot)
- Avatars display & downloading is not implemented (I'm have no idea how to make the avatar displaying look any good)
- __ONLY__ scrapped comments are supported at the moment as they are much easier to work with
- Every option starting with the "U_" prefix is not implemented but because right now there is ussually just one option
  implemented they are kind of useless and serve more like an idea on what could be added.
- The button is permanently shown for now, later it should be remade to be also created with javascript so it won't even display
  without it
- __No checks are done__ for existence of any files except input! When linking resources (video, css, js) use the path that should
  be used when the html will be opened (relative). The reason for this is because of yet undecided resulting structure.

__Incompatibility warning:__ Ironically, the "fixed" comment-json (remade to array) is now not supported as we use much simpler
parsing here. This means that currently only output directly from youtube-comment-downloader are supported. However adding support
for the array version should not be hard.

### More features ideas

- It could be nice to add some generic pony avatars in the future for scraps that dont have them
  (thisponydoesnotexists.org? or the way how boorus generate anonymous ponies?)
- Add static linking? (expand css and js to their <tags>)?

## Current report from back-end side

### What is where and what is what

This part mainly desribes what is being done where and how; if something was to be changed. It's not really important if _(you)_ are
not planing to change anything

#### convert.py

Converting logic - generates html file. Converter itself works as configuration class with defaults. First all properties are set
in _CommentConverter_ and then the ``export()`` function does the actuall writing.

#### commentModels.py

- Contains all supported comment models
- In the future should contain ``ScrappedComment``, ``Apicomment`` and ``UniversalComment`` the last one being the one we will be working with

#### CommentConverter.py

- Entry point
- Args parsing
- JSON parsing

#### script.js

very creative name I know.

- All of the js for expanding and shrinking of comment replies
- Comment html must be completely usable without JS so anything interactive must be initialized to it's "Initial" (hidden) form here
  (shrinking comments chains instead of exporting them shrinked already)
- ``autoLoad()`` Is called when ``<body>`` is loaded because i don't know how else to run on load directly (document.onLoad()
  somehow didn't worked for me from the JS), might be good idea to move it to the ``script.js`` completely

#### style.css

Well it contains some styling but it's nothing much, I think it's still a bit better than the previous version mainly because of
chaining. Currently unordered list is used for chaining replies as there will always be max 1 level of indent.

For more info about classes - reading ``converter.py:writeComments()``, ``converter.py:writeSingleComment()`` and ``style.css`` is
encuradged. I tried to make the CSS class names sound as logical as I could, however I never really worked with CSS much before so I
may have used some weird combinations or names.

Logic is mostly that everything that somehow belongs to comment has ``comment-`` prefix and it goes from there. For more info
check out ``style.css``

## What to do next

These are just few suggestions for what should have the highest priotity right now.

### To implement

Things that just wait to be implemented. 
(meaning that I'll get to implement them eventually, this is just a list of things (you) can help with if (you) wish. Or you can
 do what ever you want, I dont really care lol)

- Comment paging - find some good number of comments per page and then page them accordingly
  - The individual html-writing functions should be more generalized to make them more flexible
- Avatar downloading - this should be simple enough, we just need some balanced delays so we wont get banned by google AND die
  waiting for it to finish
- Support youtube API comments - this is not really _waiting_ to be impelented because it'll be lot of work but it should be done
  eventually - the key here will be modifying the "writing" functions to use universal comment and the conversion between
  api-scrap comment types. And the API json parsing as it is much more complex structure.
- Convertor - relative to absolute date
  - Will be huge cluster fuck
  - Must support the language comments were scrapped in
  - Accuracy will be shit but the worst case should 1/2 year if I am correct (assuming file creation date won't be changed anywhere)
  - We'll probably have to use file creation date as the it's the only other "relative" time point we have

### To figure out

Things that need to be figured out:

- How to do the actuall archiving - as we are mostly using other programs (youtube-dl, comment scrapper, ffmpeg..) we should
  probably figure out some really good way of gluing it together to be able to make it highly automatized.
- Figure out the scope of this particular _script?_ - Should we also "pack it" here? generate dir structure here? just convert
  comments and exit (making new program for the rest)?
- Directory structure for this script? It's probably not the best idea to dump everything in one dir, maybe the default scripts or
  styles should be in some ``default/`` dir or something
