#################
# Comment Utils #
#################


# To be loaded when we have comments from scrapper
class ScrappedComment:
    heart: bool  # Todo: Put download avatar into this class?
    votes: int
    photo: str  # Do test with avatar-less comment backup to see what happens when we dont have them
    author: str
    cid: str
    text: str
    time: str
    channel: str
    isReply: bool
    replies: list

    def __init__(self, json):  # This should be remade to some JSON parsing lib someday but i dont have time to create schemas and all that bullshit
        self.heart = self.__jsonLookup(json, "heart")  # Any input or improvements suggestions are very appreciated
        self.votes = self.__jsonLookup(json, "votes")
        self.photo = self.__jsonLookup(json, "photo")
        self.author = self.__jsonLookup(json, "author")
        self.cid = self.__jsonLookup(json, "cid")
        self.text = self.__jsonLookup(json, "text").replace("\n", "<br>")  # Fixes no user new lines
        self.channel = self.__jsonLookup(json, "channel")
        self.time = self.__jsonLookup(json, "time")
        self.isReply = "." in self.cid

    def __jsonLookup(self, json, key):
        """Used for cathing of missing fields and prevent crashes"""
        try:
            return json[key]
        except KeyError:
            return "ERROR: " + key  # Maybe return something more logical?

    def addReply(self, reply):
        try:
            self.replies
        except AttributeError:
            self.replies = list()
        finally:
            self.replies.append(reply)

    def hasReplies(self):
        try:
            self.replies
            return True
        except AttributeError:
            return False

    def getChannelLink(self):
        return "https://youtube.com/channel/" + self.channel

    def getCid(self):
        """Returns just the comment id without it's reply"""
        if self.isReply:
            return self.cid.split(".")[1]
        else:
            return self.cid

    def getRawCid(self):
        return self.cid

    def getParent(self):
        """Returns CID of comment this one replies to"""
        return self.cid.split(".")[0]


# To be loaded when we have comments saved from youtube API
class ApiComment:
    pass


# This will be saved to resulting archived file, it contains additional metadata
class ArchiveComment:
    author: str
    text: str
    date: int
    dateString: str
